//+------------------------------------------------------------------+
//|                              market_order_trail_direction_v1.mq4 |
//|                                                                  |
//|                                                  http://www..com |
//+------------------------------------------------------------------+


#property copyright ""
#include <stdlib.mqh>
#include <WinUser32.mqh>

//-----------------------------------------------------------------------------+
// External Variables

extern double InitialLots            =  0.1;
extern double Profit                 =  5.0;
extern int    Slippage               =  3;
extern int    OpenDistance           =  5;
extern int    OppositeDistance       = 80;
extern int    MagicNumber            = 80800812014; 
extern int    SleepTime              =  10;
extern string s4 = "== Time Filters == ";
extern int    CloseMarketOnFriday    =  22;
extern int    StartHour              =  0;    
extern int    LastHour               =  24;  

//-----------------------------------------------------------------------------+
// Global Variables

double Spread,StopLevel,FreezeLevel;
double BuyTrigger,SellTrigger,TickValue,TotalOrderProfit,Lots,lots;
double  pips2dbl,OpenPrice,BuyStopLoss,BuyTakeProfit,SellStopLoss,SellTakeProfit;
int OTCurrentTick, OTLastTick,TotalOrders,Total;
int BuyTicket,SellTicket,ErrorCode,orders;
int  pips2points,Digits.pips,i; 
bool BuyAllowed = true,SellAllowed = true;
 
//-----------------------------------------------------------------------------+
 int init ()
   {
    if (Digits == 5 || Digits == 3)
       {    
        pips2dbl = Point*10; pips2points = 10; Digits.pips = 1; 
       }
    else 
       {   
        pips2dbl = Point; pips2points =  1; Digits.pips = 0;   
       }
           
      BuyTrigger = Ask + OpenDistance * pips2dbl;
      SellTrigger = Bid - OpenDistance * pips2dbl;
      
      Spread = MarketInfo(Symbol(),MODE_SPREAD)*Point;
           
      StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
            
      FreezeLevel =MarketInfo(Symbol(),MODE_FREEZELEVEL);
      
      TickValue = MarketInfo(Symbol(),MODE_TICKVALUE);
      
    return(0);   
   }     
 
  //+---------------------------------------------------------------------------+
 int start()
   {//0 
   
             	 		 
  OTLastTick = OTCurrentTick;                      
  OTCurrentTick = OrdersTotal();                  
    if(OTCurrentTick == 0 && OTLastTick > 0)
      {
      BuyTrigger  = Ask + OpenDistance * pips2dbl;
      SellTrigger = Bid - OpenDistance * pips2dbl;
      }                                     
    if(OTCurrentTick > 0)OpenOppositeOrder();                                                               
    if(OTCurrentTick > 0)EAOrderProfit();    
                               
    if(OTCurrentTick == 0)
      {
       BuyAllowed  = true;
       SellAllowed = true; 
 
  //+----------------------------------------------------------------------------+ 
     double rsi_last =iRSI(Symbol(),0,5,0,1);
     double rsi_current =iRSI(Symbol(),0,5,0,0); 
//+----------------------------------------------------------------------------+

     for(Total = 1; Total <= OrdersTotal(); Total++)    
        Lots = MathRound(AccountBalance()/100)/1000;
        
        lots = MathPow(2,Total)*Lots;
      
//+----------------------------------------------------------------------------+     
                                                                                                                                                                                                                                                                                                                                                                        
  	 //Buy Order Condition to Open
  	 
  	  //if(rsi_last < 30 && rsi_current > 30)
   if(Ask > BuyTrigger && BuyAllowed)   
     {//5     	
	  	 RefreshRates();	  		       
       BuyTicket = OrderSend(Symbol(),OP_BUY,lots,Ask,Slippage*pips2points,0,0,"Initial Buy Order",MagicNumber,0,Green);
       if(BuyTicket > -1)     
        {//6
         BuyAllowed = false;SellAllowed = true; 
          Print(" Initial Buy Order Placed - BuyTicket: ",BuyTicket," Open Buy Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Spread: ",DoubleToStr(Spread,Digits));                                                                                                
        }//6
     else
        {//7
          ErrorCode = GetLastError();
          string ErrDesc = ErrorDescription(ErrorCode); 
                 
          string ErrAlert = StringConcatenate(" Initial Buy Order Failed: ",ErrorCode, ": ",ErrDesc);
          Alert(ErrAlert);
         
          string ErrLog = StringConcatenate(" Initial Buy Order Failed -  Ask: ",DoubleToStr(Ask,Digits)," Open Buy Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Spread: ",DoubleToStr(Spread,Digits)," Lots: ",InitialLots," Ticket: " ,BuyTicket," Stop Level: ",StopLevel," Freeze Level: ",FreezeLevel);        
          Print(ErrLog);
         }//7 
    return(0);
     }//5
     
  //-----------------------------------------------------------------------------+	  
  // Sell Order Condition to Open
     //if(rsi_last > 70 && rsi_current < 70)      
   if(Bid < SellTrigger && SellAllowed)
      {//8                                       
	  	  RefreshRates();					 		
	     SellTicket = OrderSend(Symbol(),OP_SELL,lots,Bid,Slippage*pips2points,0,0,"Initial Sell Order",MagicNumber,0,Red);	     	  
	     if(SellTicket > -1)
 		   {//9
 		     BuyAllowed = true;SellAllowed = false; 
 		     Print(" Initial Sell order Placed: ", SellTicket," Open Sell Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Spread: ",DoubleToStr(Spread,Digits));                                                                             
         }//9
      else
         {//10
           ErrorCode = GetLastError();
           ErrDesc =ErrorDescription(ErrorCode);
                   
           ErrAlert = StringConcatenate(" Initial Sell Order Failed: ",ErrorCode, ": ",ErrDesc);
           Alert(ErrAlert);
         
          ErrLog = StringConcatenate(" Initial Sell Order Failed -  Bid: ",DoubleToStr(Bid,Digits)," Open Sell Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Spread: ",DoubleToStr(Spread,Digits)," Lots: " , InitialLots," Ticket: " ,SellTicket," Stop Level: ",StopLevel," Freeze Level: ", FreezeLevel);
          Print(ErrLog);
         }//10          
      }//8               
   }//
  string SettingsComment = "TotalOrderProfit: "+TotalOrderProfit+"  Orders: "+Total+"  Carry Lots: "+lots;
  Comment(SettingsComment); 
  return(0);
  }//0
 			                       
//+------------------------------------------------------------------+
 
  void OpenOppositeOrder()
    {//0     
     int Op; 
         
     for(int Counter = OrdersTotal()-1; Counter >= 0; Counter--)     
      {//1
      if(!OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES))continue;          
         {//2
         if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)           
            {//3
             Op = OrderType();            
             if (Op == OP_BUY && (OrderOpenPrice() - OrderClosePrice())/Point >= OppositeDistance && SellAllowed)           
               {//4                                                           
                 RefreshRates();                             
                 SellTicket = OrderSend(Symbol(), OP_SELL, lots, Bid, Slippage*pips2points, 0,0, "Sell Opposite Order", MagicNumber, 0, Red);                                                   
                  if(SellTicket > -1)                   
                   {//5 
                                      
                     BuyAllowed=true;SellAllowed=false;
                                                                                                     
                     Print(" Opposite Sell Order Placed: ","Order Ticket: ",SellTicket," Spread: ",DoubleToStr(Spread,Digits)," Open Price: ",DoubleToStr(OrderOpenPrice(),Digits));                 
                  return;
                   }//5                 
               else
                   {//6                  
                    ErrorCode = GetLastError();
                    string ErrDesc =ErrorDescription(ErrorCode);
                   
                    string ErrAlert = StringConcatenate(" Open Opposite Order - Opposite Sell Failed: ",ErrorCode, ": ",ErrDesc);
                    Alert(ErrAlert);
         
                    string ErrLog = StringConcatenate(" Open Opposite Order - Bid: ",DoubleToStr(Bid,Digits)," Open Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Ticket: ",SellTicket," Spread: ",DoubleToStr(Spread,Digits)," Lots: ",InitialLots," Stop Level: ",StopLevel," Freeze Level: " ,FreezeLevel);
                    Print(ErrLog);                    
                   }//6
               }//4                      
             if(Op == OP_SELL && (OrderClosePrice() - OrderOpenPrice())/Point >= OppositeDistance && BuyAllowed)                          
                {//7                                                                                
	               RefreshRates();	          	        
                  BuyTicket = OrderSend(Symbol(), OP_BUY, lots, Ask, Slippage*pips2points, 0,0, "Buy Opposite Order", MagicNumber, 0, Green);                  
                  if(BuyTicket > -1)
                   {//8 
                                       
                     BuyAllowed=false;SellAllowed=true;
                                                                                                 
                     Print(" Opposite Buy Order Placed: ",BuyTicket," Spread: ",DoubleToStr(Spread,Digits)," Open Price: ",DoubleToStr(OrderOpenPrice(),Digits));                                   
                return;
                  }//8
               else
                  {//9                     
                    ErrorCode = GetLastError();
                    ErrDesc =ErrorDescription(ErrorCode);
                  
                    ErrAlert = StringConcatenate(" Open Opposite Order - Opposite Buy Failed: ",ErrorCode, ": ",ErrDesc);
                    Alert(ErrAlert);
         
                    ErrLog = StringConcatenate(" Open Opposite Order -  Ask: ",DoubleToStr(Ask,Digits)," Open Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Ticket: ",BuyTicket," Spread: ",DoubleToStr(Spread,Digits)," Lots: ",InitialLots," Stop Level: ",StopLevel," Freeze Level: ",FreezeLevel);
                    Print(ErrLog);
                  }//9   
               }//7
            }//3
         }//2   
      }//1          
   }//0
                            
 //-----------------------------------------------------------------------------+
         
  void EAOrderProfit()
//---- 
       {//0
        TotalOrderProfit = 0;       
               
        for(int Orders = OrdersTotal()-1; Orders >= 0; Orders--)       
          {//1
          if(!OrderSelect(Orders,SELECT_BY_POS,MODE_TRADES))continue;
            {//2
            if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)            
              {//3                             
               TotalOrderProfit += OrderProfit() + OrderCommission() + OrderSwap();                                                        
              }//3          
            }//2
          }//1                                                                 
        if(TotalOrderProfit >= Profit)CloseAll();
//----                                
       }//0 
 //-----------------------------------------------------------------------------+
void CloseAll()
 //----
       {//0
         int OrdType;
         int GLError;
               
         for(int OrderPos = OrdersTotal()-1; OrderPos >= 0; OrderPos--)       
           if(OrderSelect(OrderPos, SELECT_BY_POS, MODE_TRADES)
              && OrderMagicNumber()== MagicNumber 
              && OrderSymbol()== Symbol())                                       
             {//1
              OrdType = OrderType();
           if(OrdType == OP_BUY || OrdType==OP_SELL)
             {//2
               RefreshRates();           
               if(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),Slippage*pips2points, Yellow))                
                 {//3
                   ErrorCode = GetLastError();
                   string ErrDesc =ErrorDescription(ErrorCode);
                  
                   string ErrAlert = StringConcatenate(" Error Closing Order ",ErrorCode,": ",ErrDesc);
                   Alert(ErrAlert);
         
                   string ErrLog = StringConcatenate(" Close Price: ",DoubleToStr(OrderClosePrice(),Digits)," Ticket: ",OrderTicket()," Lots: ", lots," Stop Level: ",StopLevel," Freeze Level: ",FreezeLevel);
                   Print(ErrLog);
                 }//3
             }//2               
          }//1
//----                
       }//0 
 
  //-----------------------------------------------------------------------------+     
   // Check for ea working time && close all on Friday
    /*
      bool TradingHours()
        {   
       if(DayOfWeek()==5 && Hour()>= CloseMarketOnFriday)CloseSell();CloseBuy();
         if(DayOfWeek()0 && Hour() >= StartHour)
          if( Hour() <= LastHour) return (true);
            
      return (false);
        }
 */
  //-----------------------------------------------------------------------------+         	